Index: /trunk/Common/cm_string.h
===================================================================
--- /trunk/Common/cm_string.h	(revision 15)
+++ /trunk/Common/cm_string.h	(revision 16)
@@ -7,4 +7,5 @@
 
 char* cm_strcat(const char* a, const char* b);
+char* cm_strcat3(const char* a, const char* b, const char* c);
 char* cm_strdup(const char* str);
 char* cm_trimstart(const char* str);
Index: /trunk/Common/string.c
===================================================================
--- /trunk/Common/string.c	(revision 15)
+++ /trunk/Common/string.c	(revision 16)
@@ -11,4 +11,11 @@
 	memcpy(str + strlen(a), b, strlen(b));
 	str[strlen(a) + strlen(b)] = 0;
+	return str;
+}
+
+char* cm_strcat3(const char* a, const char* b, const char* c) {
+	char* tmp = cm_strcat(a, b);
+	char* str = cm_strcat(tmp, c);
+	free(tmp);
 	return str;
 }
Index: /trunk/Server/Makefile
===================================================================
--- /trunk/Server/Makefile	(revision 15)
+++ /trunk/Server/Makefile	(revision 16)
@@ -6,5 +6,5 @@
 .SUFFIXES: .c .o
 
-OBJS = version.o main.o config.o server.o ssl.o
+OBJS = version.o main.o config.o server.o ssl.o http.o
 
 all: tewi$(EXEC)
Index: /trunk/Server/config.c
===================================================================
--- /trunk/Server/config.c	(revision 15)
+++ /trunk/Server/config.c	(revision 16)
@@ -1,3 +1,5 @@
 /* $Id$ */
+
+#define SOURCE
 
 #include "tw_config.h"
Index: /trunk/Server/http.c
===================================================================
--- /trunk/Server/http.c	(revision 16)
+++ /trunk/Server/http.c	(revision 16)
@@ -0,0 +1,243 @@
+/* $Id$ */
+
+#define SOURCE
+
+#include "tw_http.h"
+
+#include "tw_server.h"
+
+#include <cm_log.h>
+#include <cm_string.h>
+
+#include <stdbool.h>
+#include <stdlib.h>
+#include <sys/socket.h>
+
+void tw_free_request(struct tw_http_request* req) {
+	if(req->method != NULL) free(req->method);
+	if(req->path != NULL) free(req->path);
+	if(req->headers != NULL) {
+		int i;
+		for(i = 0; req->headers[i] != NULL; i++) free(req->headers[i]);
+		free(req->headers);
+	}
+	if(req->body != NULL) free(req->body);
+	if(req->version != NULL) free(req->version);
+}
+
+int tw_http_parse(SSL* ssl, int sock, struct tw_http_request* req) {
+	char buffer[512];
+	char cbuf[2];
+	int phase = 0;
+	fd_set fds;
+
+	bool bad = false;
+
+	cbuf[1] = 0;
+
+	req->method = NULL;
+	req->path = NULL;
+	req->headers = NULL;
+	req->body = NULL;
+	req->version = NULL;
+
+	char* header = malloc(1);
+	header[0] = 0;
+	int nl = 0;
+
+	while(1) {
+		FD_ZERO(&fds);
+		FD_SET(sock, &fds);
+		struct timeval tv;
+		tv.tv_sec = 5;
+		tv.tv_usec = 0;
+		int n = select(FD_SETSIZE, &fds, NULL, NULL, &tv);
+		if(n == 0) break;
+		int len = tw_read(ssl, sock, buffer, 512);
+		if(len <= 0) break;
+		int i;
+		for(i = 0; i < len; i++) {
+			char c = buffer[i];
+			if(phase == 0) {
+				if(c == ' ') {
+					if(req->method == NULL) {
+						tw_free_request(req);
+						bad = true;
+						goto getout;
+					} else {
+						phase++;
+					}
+				} else {
+					if(req->method == NULL) {
+						req->method = malloc(1);
+						req->method[0] = 0;
+					}
+					cbuf[0] = c;
+					char* tmp = req->method;
+					req->method = cm_strcat(tmp, cbuf);
+					free(tmp);
+				}
+			} else if(phase == 1) {
+				if(c == ' ') {
+					if(req->path == NULL) {
+						tw_free_request(req);
+						bad = true;
+						goto getout;
+					} else {
+						phase++;
+					}
+				} else {
+					if(req->path == NULL) {
+						req->path = malloc(1);
+						req->path[0] = 0;
+					}
+					cbuf[0] = c;
+					char* tmp = req->path;
+					req->path = cm_strcat(tmp, cbuf);
+					free(tmp);
+				}
+			} else if(phase == 2) {
+				if(c == '\n') {
+					if(req->version == NULL) {
+						tw_free_request(req);
+						bad = true;
+						goto getout;
+					} else {
+						/* We have Method, Path, Version now */
+
+						if(strcmp(req->version, "HTTP/1.1") != 0 && strcmp(req->version, "HTTP/1.0") != 0) {
+							cm_log("HTTP", "Bad HTTP Version");
+							bad = true;
+							goto getout;
+						}
+
+						int j;
+						char* p = malloc(1);
+						p[0] = 0;
+						for(j = 0; req->path[j] != 0; j++) {
+							if(req->path[j] == '/') {
+								cbuf[0] = '/';
+								for(; req->path[j] != 0 && req->path[j] == '/'; j++)
+									;
+								j--;
+							} else {
+								cbuf[0] = req->path[j];
+							}
+							char* tmp = p;
+							p = cm_strcat(tmp, cbuf);
+							free(tmp);
+						}
+						free(req->path);
+						req->path = p;
+
+						int incr = 0;
+						p = malloc(1);
+						p[0] = 0;
+						for(j = 0;; j++) {
+							if(req->path[j] == '/' || req->path[j] == 0) {
+								char oldc = req->path[j];
+								cbuf[0] = oldc;
+								req->path[j] = 0;
+
+								char* pth = req->path + incr;
+
+								if(strcmp(pth, "..") == 0) {
+									int k;
+									if(p[strlen(p) - 1] == '/') p[strlen(p) - 1] = 0;
+									for(k = strlen(p) - 1; k >= 0; k--) {
+										if(p[k] == '/') {
+											p[k + 1] = 0;
+											break;
+										}
+									}
+									if(strlen(p) == 0) {
+										free(p);
+										p = cm_strdup("/");
+									}
+								} else if(strcmp(pth, ".") == 0) {
+								} else {
+									char* tmp = p;
+									p = cm_strcat3(tmp, pth, cbuf);
+									free(tmp);
+								}
+
+								incr = j + 1;
+								if(oldc == 0) break;
+							}
+						}
+						free(req->path);
+						req->path = p;
+
+						cm_log("HTTP", "Request: %s %s %s", req->method, req->path, req->version);
+
+						phase++;
+					}
+				} else if(c != '\r') {
+					if(req->version == NULL) {
+						req->version = malloc(1);
+						req->version[0] = 0;
+					}
+					cbuf[0] = c;
+					char* tmp = req->version;
+					req->version = cm_strcat(tmp, cbuf);
+					free(tmp);
+				}
+			} else if(phase == 3) {
+				if(c == '\n') {
+					nl++;
+					if(nl == 2) {
+						phase++;
+						goto getout;
+					} else {
+						if(req->headers == NULL) {
+							req->headers = malloc(sizeof(*req->headers));
+							req->headers[0] = NULL;
+						}
+						int j;
+						for(j = 0; header[j] != 0; j++) {
+							if(header[j] == ':') {
+								header[j] = 0;
+								j++;
+								for(; header[j] != 0 && (header[j] == ' ' || header[j] == '\t'); j++)
+									;
+								char* kv = header;
+								char* vv = header + j;
+
+								char** old = req->headers;
+								int k;
+								for(k = 0; old[k] != NULL; k++)
+									;
+								req->headers = malloc(sizeof(*req->headers) * (k + 3));
+								for(k = 0; old[k] != NULL; k++) req->headers[k] = old[k];
+								req->headers[k] = cm_strdup(kv);
+								req->headers[k + 1] = cm_strdup(vv);
+								req->headers[k + 2] = NULL;
+								free(old);
+
+								cm_log("HTTP", "Header: %s: %s", kv, vv);
+
+								break;
+							}
+						}
+						free(header);
+						header = malloc(1);
+						header[0] = 0;
+					}
+				} else if(c != '\r') {
+					nl = 0;
+					cbuf[0] = c;
+					char* tmp = header;
+					header = cm_strcat(tmp, cbuf);
+					free(tmp);
+				}
+			}
+		}
+	}
+getout:
+	free(header);
+	if(bad) {
+		tw_free_request(req);
+		return 1;
+	}
+	return 0;
+}
Index: /trunk/Server/main.c
===================================================================
--- /trunk/Server/main.c	(revision 15)
+++ /trunk/Server/main.c	(revision 16)
@@ -1,7 +1,10 @@
 /* $Id$ */
+
+#define SOURCE
 
 #include <stdio.h>
 #include <stdbool.h>
 #include <string.h>
+#include <signal.h>
 
 #include <openssl/opensslv.h>
@@ -50,4 +53,7 @@
 	}
 	cm_log("Daemon", "Ready");
+#ifndef __MINGW32__
+	signal(SIGCHLD, SIG_IGN);
+#endif
 	tw_server_loop();
 }
Index: /trunk/Server/server.c
===================================================================
--- /trunk/Server/server.c	(revision 15)
+++ /trunk/Server/server.c	(revision 16)
@@ -1,3 +1,5 @@
 /* $Id$ */
+
+#define SOURCE
 
 #include "tw_server.h"
@@ -5,4 +7,5 @@
 #include "tw_ssl.h"
 #include "tw_config.h"
+#include "tw_http.h"
 
 #include <unistd.h>
@@ -111,4 +114,20 @@
 	}
 	return 0;
+}
+
+size_t tw_read(SSL* ssl, int s, void* data, size_t len) {
+	if(ssl == NULL) {
+		return recv(s, data, len, 0);
+	} else {
+		return SSL_read(ssl, data, len);
+	}
+}
+
+size_t tw_write(SSL* ssl, int s, void* data, size_t len) {
+	if(ssl == NULL) {
+		return send(s, data, len, 0);
+	} else {
+		return SSL_write(ssl, data, len);
+	}
 }
 
@@ -140,6 +159,8 @@
 		sslworks = true;
 	}
+	struct tw_http_request req;
+	int ret = tw_http_parse(s, sock, &req);
 cleanup:
-	if(sslworks){
+	if(sslworks) {
 		SSL_shutdown(s);
 	}
Index: /trunk/Server/ssl.c
===================================================================
--- /trunk/Server/ssl.c	(revision 15)
+++ /trunk/Server/ssl.c	(revision 16)
@@ -1,3 +1,5 @@
 /* $Id$ */
+
+#define SOURCE
 
 #include "tw_ssl.h"
Index: /trunk/Server/tw_http.h
===================================================================
--- /trunk/Server/tw_http.h	(revision 16)
+++ /trunk/Server/tw_http.h	(revision 16)
@@ -0,0 +1,25 @@
+/* $Id$ */
+
+#ifndef __TW_HTTP_H__
+#define __TW_HTTP_H__
+
+struct tw_http_request {
+	char* method;
+	char* path;
+	char* version;
+	char** headers;
+	char* body;
+};
+
+struct tw_http_response {
+	char** headers;
+};
+
+struct tw_http_tool {};
+
+#ifdef SOURCE
+#include <openssl/ssl.h>
+int tw_http_parse(SSL* ssl, int sock, struct tw_http_request* req);
+#endif
+
+#endif
Index: /trunk/Server/tw_server.h
===================================================================
--- /trunk/Server/tw_server.h	(revision 15)
+++ /trunk/Server/tw_server.h	(revision 16)
@@ -4,6 +4,10 @@
 #define __TW_SERVER_H__
 
+#include <openssl/ssl.h>
+
 int tw_server_init(void);
 void tw_server_loop(void);
+size_t tw_read(SSL* ssl, int s, void* data, size_t len);
+size_t tw_write(SSL* ssl, int s, void* data, size_t len);
 
 #endif
Index: /trunk/Server/version.c
===================================================================
--- /trunk/Server/version.c	(revision 15)
+++ /trunk/Server/version.c	(revision 16)
@@ -1,3 +1,5 @@
 /* $Id$ */
+
+#define SOURCE
 
 #include "tw_version.h"